##########################################################################
#
#       TITLE: sitevariables.pm
#
#       FUNCTION: Include file housing variables specific to the
#       asthetics of each individual install as well as options
#       crucial to the operation of the script.  Read the readme
#       for installation instructions.
#
#       DATE: last edited 12-08-2003
#
#       AUTHOR: Erin Spice
#
#       PACKAGE: My Blog
#
##########################################################################
package svb;

# AESTHETIC OPTIONS ######################################################

#Specify a title for your blog
our $title = "My Blog";

#Specify a template file for the page and a template for each post
our $templatefile = "template.html";
our $post_template = "post_template.html";


#Specify font and color preferences here
our $fontface = "verdana";
our $tablebg = "#c9dfea"; # background color for the very outside tables
our $tableborder = "#376f9e"; # outline color for the very outside tables
our $lightcolor = "#c9dfea"; # background color for the tables
our $darkcolor = "#376f9e"; # outline color for tables and font
our @cellcolors = ($lightcolor,"#e3e6f9"); # two colors of alternating cells in ad table
our $headersize = "4"; # size for large lettering
our $smallsize = "2"; # size for regular text
our $fontheader = "<b><font face=$fontface size=$headersize color=$darkcolor>";
our $headercellcolor = "#adb6ea";
our $fontsmall = "<font face=$fontface size=$smallsize color=$darkcolor>";
#Specify a background color in HEX if you want one.  Default is white #FFFFFF
our $bgcolor = '#FFFFFF';

##########################################################################



# PROGRAM OPTIONS ########################################################

#Specify a path to the directory your pictures are in
our $htmlpath = "http://yourdomain.com/blog"; # url to folder to store files in
our $htmlpicpath = "http://yourdomain.com/blog/icons"; # url to folder to store icons in
our $htmlsystempath = "/home/username/public_html/blog/"; # full system path to folder to store files in
our $maxpicsize = 50000; # maximum file size in kilobytes 50000 = 50 megs
our $full_width = 600;
our $preview_width = 250;
our $use_imagemagick = "yes"; # use imagemagick to resize pictures and make thumbnails. If this is no, full sized image will be used.
our $sendmail = "/usr/lib/sendmail -io -t"; # path to sendmail plus relevant arguments. If not sure, leave -io -t.
our $webmaster = 'user@domain.com'; # your email address for comments - must be in SINGLE quotes.
our $picalign = "right"; # how to align picture for post ie, "right" "left" "center"
our $textmax = 1200; # max text length per entry before abbreviating for front page, or set to 0 to display all
our $page = "3"; # number of blog entries per page, or set to 0 to display all







1;
